/* 
    3D Engine

    2005 Jason Hunt
    justinsanemsu@hotmail.com

    file: const.h

    Constants
*/

#ifndef CONST_H
#define CONST_H

#define ID_TIME   1
#define ID_SEC    2

#define do_profile  0

#define texture_size    128                     // size of generated texture
#define num_tx     6

#define display_x 800                           // display window size
#define display_y 600

#define half_display_x (display_x/2)
#define half_display_y (display_y/2)

#define inital_max_objects  20                  // inital size of object pointer array

#define FOV    60.0 * (M_PI / 180.0)            // field of view
#define depth_x  ((display_x/2) / tan(FOV/2))   // x scaling factor
#define depth_y  ((display_y/2) / tan(FOV/2))   // y scaling factor

#define mouse_sensitivity 1.5

#define look_x_max (M_PI/ 2.0)
#define look_x_min (-M_PI/ 2.0)


#endif

