/* 
    3D Engine

    2005 Jason Hunt
    justinsanemsu@hotmail.com

    file: display.cpp
*/

#include <stdlib.h>
#include <stdio.h>
#include <windows.h>

#include "display.h"
#include "profile.h"

extern world_class world;
extern HWND main_win;
extern HDC main_dc;
extern bool display_fps;

color_type buffer[display_x * display_y];   // off screen buffer
BITMAPINFO buffer_info;                     // windows information about buffer

unsigned int fps = 0;       // current frames per second
unsigned int frames = 0;    // frame counter


/* setup offscreen buffer */
void create_buffer( void )
{
	// Set the new Bitmap
	buffer_info.bmiHeader.biSize = sizeof(buffer_info.bmiHeader);
	buffer_info.bmiHeader.biWidth = display_x;
	buffer_info.bmiHeader.biHeight = display_y;
	buffer_info.bmiHeader.biPlanes = 1;
	buffer_info.bmiHeader.biBitCount = 32;
	buffer_info.bmiHeader.biCompression = BI_RGB;
	buffer_info.bmiHeader.biSizeImage = display_x * display_y * 4;
	buffer_info.bmiHeader.biClrUsed = 0;
	buffer_info.bmiHeader.biClrImportant = 0;
}
/* end of create_buffer */



/* show the text buffer on the screen */
void display(void)
{
    // copy frame buffer
    SetDIBitsToDevice(main_dc, 0, 0, display_x, display_y, 0, 0, 0, display_y,  buffer, &buffer_info,DIB_RGB_COLORS);

    if (display_fps)
    {
        char b[400];
        sprintf(b, "FPS: %d   Objects: %d  Total faces: %d  Visible faces: %d", fps, 
                   world.num_object, world.total_triangle, world.num_visible_triangle);

        TextOut(main_dc, 0, 0, b, strlen(b));
    }

    ValidateRect(main_win, NULL);

    frames++;
}
/* end of display_text_area */


