/* 
    3D Engine

    2005 Jason Hunt
    justinsanemsu@hotmail.com

    file: input.cpp
*/

#include <windows.h>
#include <math.h>
#include <stdio.h>

#include "main.h"
#include "input.h"
#include "display.h"
#include "world.h"


bool display_fps = false;;


bool keys[256]; // true of that key is pressed down

extern bool paused;
extern bool shader;

/* setup key table */
void input_start( void )
{
    memset(keys, 0, 256);
}
/* end of input_start */


/* called when a key is pressed */
void process_key_down(WPARAM wParam)
{
    keys[wParam % 256] = true;

    // escape key
    if (wParam == VK_ESCAPE) system_shutdown(); else
    if (wParam == 'P') paused = !paused;
    if (wParam == 'O') shader = !shader;
    if (wParam == 'F') display_fps = !display_fps;
}
/* end of process key down */


/* called when a key is released */
void process_key_up( WPARAM wParam )
{
    keys[wParam % 256] = false;
}
/* end of process key up */




