/* 
    3D Engine

    2005 Jason Hunt
    justinsanemsu@hotmail.com

    file: object.h
*/

#ifndef OBJECT_H
#define OBJECT_H

#include "triangle.h"
#include "point3d.h"
#include "camera.h"
#include "types.h"
#include "world.h"

class object_class 
{
  public:

    bool load_from_file( char *filename );

    void unload( void );

    void transform( camera_class camera );

    void randomize_placement( void );

    bool okay_to_move(point3d p);

    void set_color(unsigned char r, unsigned char g, unsigned char b);

    void draw( void );
    void move( void );

// private:
    
    triangle_class *triangle_data;
    unsigned int num_triangle;

    point3d position;
    point3d direction;

    point3d direction_rate;
    point3d position_rate;

    trig_type trig;
    
    vertex_class *vertex_data;

    double radius;

    bool shade;

    unsigned num_vertex;
};

#endif



