#include <windows.h>
#include <time.h>
#include <stdio.h>
#include <string.h>

#include "const.h"
#include "debug.h"

#define max_profile 100


#define max_str     1000


typedef struct profile_entry
{
    long int start;
    char name[64];
};


profile_entry profiles[max_profile];
unsigned int num_profile = 0;


char strings[max_str][128];
unsigned int num_str = 0;


LARGE_INTEGER freq;

void init_profile( void )
{
    QueryPerformanceFrequency(&freq);
}



void start_profile( char *name )
{
    if (!do_profile ) return;

    if (num_profile >= max_profile) return;

    strcpy(profiles[num_profile].name, name);

   if (num_str < max_str)
        sprintf(strings[num_str++], "start_profile (%s)", name);

    LARGE_INTEGER tmp;

    QueryPerformanceCounter(&tmp);

    profiles[num_profile].start = tmp.LowPart;

    num_profile++;
}


void stop_profile( void )
{
    if (!do_profile ) return;

    if (num_profile <= 0) return;

    LARGE_INTEGER stop;
    
    QueryPerformanceCounter(&stop);

    num_profile--;

    double runtime = (stop.LowPart - profiles[num_profile].start) / (double) freq.LowPart;

    if (num_str < max_str)
        sprintf(strings[num_str++], "(%40s) time: %12.10f seconds", profiles[num_profile].name, runtime);
}




void save_profile( void )
{
    if (!do_profile) return;

    for (int i = 0; i < num_str; i++)
        add_debug("", strings[i]);
}


