/* 
    3D Engine

    2005 Jason Hunt
    justinsanemsu@hotmail.com

    file: texture.cpp
*/

#include <windows.h>
#include <stdio.h>
#include "texture.h"
#include "world.h"

extern world_class world;
extern HWND main_win;

void load_texture(char *filename, unsigned int index)
{
    HBITMAP hBitmap = (HBITMAP)LoadImage(NULL, filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

    if (hBitmap == NULL)
    {
        char buffer[300];
        sprintf(buffer, "Unable to load bitmap file (%s)", filename);
        MessageBox(main_win, buffer, "Error", 0);
        return;
    }

    BITMAP bm;  
    GetObject(hBitmap, sizeof(bm), &bm);

	BITMAPINFO BI; 
	ZeroMemory(&BI,sizeof(BITMAPINFO));
	BI.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	BI.bmiHeader.biWidth = bm.bmWidth;
	BI.bmiHeader.biHeight = bm.bmHeight;
	BI.bmiHeader.biPlanes = 1;
	BI.bmiHeader.biBitCount = 32;

    GetDIBits(GetDC(main_win), hBitmap, 0, 128,  world.texture[index],  &BI, DIB_RGB_COLORS);   

    DeleteObject(hBitmap);
}



void free_texture(texture_type &t)
{


}

