/* 
    3D Engine

    2005 Jason Hunt
    justinsanemsu@hotmail.com

    file: triangle.h
*/

#ifndef TRIANGLE_H
#define TRIANGLE_H

#include "types.h"
#include "vertex.h"
#include "const.h"

class triangle_class 
{
  public:

    vertex_class *vertex[3];

    bool is_visible( void );

    void compute_normal( void );

    void compute_values( void );

    void draw();

//private
    float average_z;

    int mutate_dir;

    color_type color;

    point3d center;
    point3d normal;

    point2d t_cords[3];

    int tx_num;

    double light;
    bool shade;
    bool t_map;

    triangle_class *next; // pointer to the next on screen triangle
};

extern color_type buffer[display_x * display_y]; 

#endif

