/* 
    3D Engine

    2005 Jason Hunt
    justinsanemsu@hotmail.com

    file: world.h
*/


#ifndef WORLD_H
#define WORLD_H

#include <windows.h>
#include "types.h"
#include "const.h"
#include "object.h"
#include "camera.h"

class world_class 
{
  public:

    void start_engine();
    void stop_engine();

    void check_input( void );

    void render_frame(HWND window);

    void load_object_from_file(char *filename);
    void add_objects( unsigned int num );

    void add_cube( float size, unsigned int tx_num, bool shade );

    void add_sphere( unsigned int points, bool shade, unsigned int tx_num);
    void add_test( void );

    void fire( void );
    void add_block (void);
    void insert_triangle( triangle_class *t);

    void reallocate_object_memory( void );

    void make_textures( void );

   int check_area(point3d p, float size);

//  private:

    object_class **objects;

    unsigned int max_object;
    unsigned int num_object;

    triangle_class *visible_triangles; // start of linked list of trianlges;

    unsigned int num_visible_triangle;

    camera_class camera;

    unsigned int total_triangle;

    color_type texture[num_tx][texture_size][texture_size];

    point3d light_source;
};


#endif

